Index: /LMDZ5/branches/testing/libf/phylmd/concvl.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/concvl.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/concvl.F90	(revision 2056)
@@ -1,22 +1,28 @@
-SUBROUTINE concvl(iflag_clos, dtime, paprs, pplay, t, q, t_wake, q_wake, &
-    s_wake, u, v, tra, ntra, ale, alp, sig1, w01, d_t, d_q, d_u, d_v, d_tra, &
-    rain, snow, kbas, ktop, sigd, cbmf, plcl, plfc, wbeff, upwd, dnwd, &
-    dnwdbis, ma, mip, vprecip, cape, cin, tvp, tconv, iflag, pbase, bbase, &
-    dtvpdt1, dtvpdq1, dplcldt, dplcldr, qcondc, wd, pmflxr, pmflxs, & ! RomP
-                                                                      ! >>>
-  ! !     .             da,phi,mp,dd_t,dd_q,lalim_conv,wght_th)
-    da, phi, mp, phi2, d1a, dam, sij, clw, elij, & ! RomP
-    dd_t, dd_q, lalim_conv, wght_th, & ! RomP
-    evap, ep, epmlmmm, eplamm, &   ! RomP
-    wdtraina, wdtrainm) ! RomP
-  ! RomP <<<
-  ! **************************************************************
-  ! *
-  ! CONCVL                                                      *
-  ! *
-  ! *
-  ! written by   : Sandrine Bony-Lena, 17/05/2003, 11.16.04    *
-  ! modified by :                                               *
-  ! **************************************************************
+SUBROUTINE concvl(iflag_clos, &
+                  dtime, paprs, pplay, &
+                  t, q, t_wake, q_wake, s_wake, u, v, tra, ntra, &
+                  Ale, Alp, sig1, w01, &
+                  d_t, d_q, d_u, d_v, d_tra, &
+                  rain, snow, kbas, ktop, sigd, &
+                  cbmf, plcl, plfc, wbeff, upwd, dnwd, dnwdbis, &
+                  Ma, mip, Vprecip, &
+                  cape, cin, tvp, Tconv, iflag, &
+                  pbase, bbase, dtvpdt1, dtvpdq1, dplcldt, dplcldr, &
+                  qcondc, wd, pmflxr, pmflxs, &
+!RomP >>>
+!!     .             da,phi,mp,dd_t,dd_q,lalim_conv,wght_th)
+                  da, phi, mp, phi2, d1a, dam, sij, clw, elij, &     ! RomP
+                  dd_t, dd_q, lalim_conv, wght_th, &                 ! RomP
+                  evap, ep, epmlmMm, eplaMm, &                       ! RomP
+                  wdtrainA, wdtrainM, wght)                          ! RomP+RL
+!RomP <<<
+! **************************************************************
+! *
+! CONCVL                                                      *
+! *
+! *
+! written by   : Sandrine Bony-Lena, 17/05/2003, 11.16.04    *
+! modified by :                                               *
+! **************************************************************
 
 
@@ -24,44 +30,52 @@
   USE infotrac, ONLY: nbtr
   IMPLICIT NONE
-  ! ======================================================================
-  ! Auteur(s): S. Bony-Lena (LMD/CNRS) date: ???
-  ! Objet: schema de convection de Emanuel (1991) interface
-  ! ======================================================================
-  ! Arguments:
-  ! dtime--input-R-pas d'integration (s)
-  ! s-------input-R-la valeur "s" pour chaque couche
-  ! sigs----input-R-la valeur "sigma" de chaque couche
-  ! sig-----input-R-la valeur de "sigma" pour chaque niveau
-  ! psolpa--input-R-la pression au sol (en Pa)
-  ! pskapa--input-R-exponentiel kappa de psolpa
-  ! h-------input-R-enthalpie potentielle (Cp*T/P**kappa)
-  ! q-------input-R-vapeur d'eau (en kg/kg)
-
-  ! work*: input et output: deux variables de travail,
-  ! on peut les mettre a 0 au debut
-  ! ALE-----input-R-energie disponible pour soulevement
-  ! ALP-----input-R-puissance disponible pour soulevement
-
-  ! d_h-----output-R-increment de l'enthalpie potentielle (h)
-  ! d_q-----output-R-increment de la vapeur d'eau
-  ! rain----output-R-la pluie (mm/s)
-  ! snow----output-R-la neige (mm/s)
-  ! upwd----output-R-saturated updraft mass flux (kg/m**2/s)
-  ! dnwd----output-R-saturated downdraft mass flux (kg/m**2/s)
-  ! dnwd0---output-R-unsaturated downdraft mass flux (kg/m**2/s)
-  ! Ma------output-R-adiabatic ascent mass flux (kg/m2/s)
-  ! mip-----output-R-mass flux shed by adiabatic ascent (kg/m2/s)
-  ! Vprecip-output-R-vertical profile of precipitations (kg/m2/s)
-  ! Tconv---output-R-environment temperature seen by convective scheme (K)
-  ! Cape----output-R-CAPE (J/kg)
-  ! Cin ----output-R-CIN  (J/kg)
-  ! Tvp-----output-R-Temperature virtuelle d'une parcelle soulevee
-  ! adiabatiquement a partir du niveau 1 (K)
-  ! deltapb-output-R-distance entre LCL et base de la colonne (<0 ; Pa)
-  ! Ice_flag-input-L-TRUE->prise en compte de la thermodynamique de la glace
-  ! dd_t-----output-R-increment de la temperature du aux descentes
-  ! precipitantes
-  ! dd_q-----output-R-increment de la vapeur d'eau du aux desc precip
-  ! ======================================================================
+! ======================================================================
+! Auteur(s): S. Bony-Lena (LMD/CNRS) date: ???
+! Objet: schema de convection de Emanuel (1991) interface
+! ======================================================================
+! Arguments:
+! dtime--input-R-pas d'integration (s)
+! s-------input-R-la vAleur "s" pour chaque couche
+! sigs----input-R-la vAleur "sigma" de chaque couche
+! sig-----input-R-la vAleur de "sigma" pour chaque niveau
+! psolpa--input-R-la pression au sol (en Pa)
+! pskapa--input-R-exponentiel kappa de psolpa
+! h-------input-R-enthAlpie potentielle (Cp*T/P**kappa)
+! q-------input-R-vapeur d'eau (en kg/kg)
+
+! work*: input et output: deux variables de travail,
+! on peut les mettre a 0 au debut
+! ALE--------input-R-energie disponible pour soulevement
+! ALP--------input-R-puissance disponible pour soulevement
+
+! d_h--------output-R-increment de l'enthAlpie potentielle (h)
+! d_q--------output-R-increment de la vapeur d'eau
+! rain-------output-R-la pluie (mm/s)
+! snow-------output-R-la neige (mm/s)
+! upwd-------output-R-saturated updraft mass flux (kg/m**2/s)
+! dnwd-------output-R-saturated downdraft mass flux (kg/m**2/s)
+! dnwd0------output-R-unsaturated downdraft mass flux (kg/m**2/s)
+! Ma---------output-R-adiabatic ascent mass flux (kg/m2/s)
+! mip--------output-R-mass flux shed by adiabatic ascent (kg/m2/s)
+! Vprecip----output-R-vertical profile of precipitations (kg/m2/s)
+! Tconv------output-R-environment temperature seen by convective scheme (K)
+! Cape-------output-R-CAPE (J/kg)
+! Cin -------output-R-CIN  (J/kg)
+! Tvp--------output-R-Temperature virtuelle d'une parcelle soulevee
+! adiabatiquement a partir du niveau 1 (K)
+! deltapb----output-R-distance entre LCL et base de la colonne (<0 ; Pa)
+! Ice_flag---input-L-TRUE->prise en compte de la thermodynamique de la glace
+! dd_t-------output-R-increment de la temperature du aux descentes precipitantes
+! dd_q-------output-R-increment de la vapeur d'eau du aux desc precip
+! lalim_conv-
+! wght_th----
+! evap-------output-R
+! ep---------output-R
+! epmlmMm----output-R
+! eplaMm-----output-R
+! wdtrainA---output-R
+! wdtrainM---output-R
+! wght-------output-R
+! ======================================================================
 
 
@@ -79,5 +93,5 @@
   REAL sig1(klon, klev), w01(klon, klev), ptop2(klon)
   REAL pmflxr(klon, klev+1), pmflxs(klon, klev+1)
-  REAL ale(klon), alp(klon)
+  REAL Ale(klon), Alp(klon)
 
   REAL d_t(klon, klev), d_q(klon, klev), d_u(klon, klev), d_v(klon, klev)
@@ -90,20 +104,21 @@
   REAL upwd(klon, klev), dnwd(klon, klev), dnwdbis(klon, klev)
 
-  ! !       REAL Ma(klon,klev), mip(klon,klev),Vprecip(klon,klev)     !jyg
-  REAL ma(klon, klev), mip(klon, klev), vprecip(klon, klev+1) !jyg
+!!       REAL Ma(klon,klev), mip(klon,klev),Vprecip(klon,klev)     !jyg
+  REAL Ma(klon, klev), mip(klon, klev), Vprecip(klon, klev+1)      !jyg
+  REAL wght(klon, klev)                                            !RL
 
   REAL da(klon, klev), phi(klon, klev, klev), mp(klon, klev)
-  ! RomP >>>
+! RomP >>>
   REAL phi2(klon, klev, klev)
   REAL d1a(klon, klev), dam(klon, klev)
   REAL sij(klon, klev, klev), clw(klon, klev), elij(klon, klev, klev)
-  REAL wdtraina(klon, klev), wdtrainm(klon, klev)
+  REAL wdtrainA(klon, klev), wdtrainM(klon, klev)
   REAL evap(klon, klev), ep(klon, klev)
-  REAL epmlmmm(klon, klev, klev), eplamm(klon, klev)
-  ! RomP <<<
+  REAL epmlmMm(klon, klev, klev), eplaMm(klon, klev)
+! RomP <<<
   REAL cape(klon), cin(klon), tvp(klon, klev)
-  REAL tconv(klon, klev)
-
-  ! CR:test: on passe lentr et alim_star des thermiques
+  REAL Tconv(klon, klev)
+
+!CR:test: on passe lentr et alim_star des thermiques
   INTEGER lalim_conv(klon)
   REAL wght_th(klon, klev)
@@ -111,6 +126,6 @@
   REAL em_sig2feed ! sigma at upper bound of feeding layer
   REAL em_wght(klev) ! weight density determining the feeding mixture
-  ! on enleve le save
-  ! SAVE em_sig1feed,em_sig2feed,em_wght
+!on enleve le save
+! SAVE em_sig1feed,em_sig2feed,em_wght
 
   INTEGER iflag(klon)
@@ -127,64 +142,64 @@
   REAL zx_t, zdelta, zx_qs, zcor
 
-  ! INTEGER iflag_mix
-  ! SAVE iflag_mix
+!   INTEGER iflag_mix
+!   SAVE iflag_mix
   INTEGER noff, minorig
   INTEGER i, k, itra
   REAL qs(klon, klev), qs_wake(klon, klev)
   REAL cbmf(klon), plcl(klon), plfc(klon), wbeff(klon)
-  ! LF       SAVE cbmf
-  ! IM/JYG      REAL, SAVE, ALLOCATABLE :: cbmf(:)
-  ! cc$OMP THREADPRIVATE(cbmf)!
+!LF          SAVE cbmf
+!IM/JYG      REAL, SAVE, ALLOCATABLE :: cbmf(:)
+!!!$OMP THREADPRIVATE(cbmf)!
   REAL cbmflast(klon)
   INTEGER ifrst
   SAVE ifrst
   DATA ifrst/0/
-  !$OMP THREADPRIVATE(ifrst)
-
-
-  ! Variables supplementaires liees au bilan d'energie
-  ! Real paire(klon)
-  ! LF      Real ql(klon,klev)
-  ! Save paire
-  ! LF      Save ql
-  ! LF      Real t1(klon,klev),q1(klon,klev)
-  ! LF      Save t1,q1
-  ! Data paire /1./
+!$OMP THREADPRIVATE(ifrst)
+
+
+! Variables supplementaires liees au bilan d'energie
+! Real paire(klon)
+!LF      Real ql(klon,klev)
+! Save paire
+!LF      Save ql
+!LF      Real t1(klon,klev),q1(klon,klev)
+!LF      Save t1,q1
+! Data paire /1./
   REAL, SAVE, ALLOCATABLE :: ql(:, :), q1(:, :), t1(:, :)
-  !$OMP THREADPRIVATE(ql, q1, t1)
-
-  ! Variables liees au bilan d'energie et d'enthalpi
+!$OMP THREADPRIVATE(ql, q1, t1)
+
+! Variables liees au bilan d'energie et d'enthAlpi
   REAL ztsol(klon)
-  REAL h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot, h_qs_tot, qw_tot, ql_tot, &
-    qs_tot, ec_tot
-  SAVE h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot, h_qs_tot, qw_tot, ql_tot, &
-    qs_tot, ec_tot
-  !$OMP THREADPRIVATE(h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot)
-  !$OMP THREADPRIVATE(h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot)
-  REAL d_h_vcol, d_h_dair, d_qt, d_qw, d_ql, d_qs, d_ec
-  REAL d_h_vcol_phy
-  REAL fs_bound, fq_bound
-  SAVE d_h_vcol_phy
-  !$OMP THREADPRIVATE(d_h_vcol_phy)
-  REAL zero_v(klon)
+  REAL        h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot, &
+              h_qs_tot, qw_tot, ql_tot, qs_tot, ec_tot
+  SAVE        h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot, &
+              h_qs_tot, qw_tot, ql_tot, qs_tot, ec_tot
+!$OMP THREADPRIVATE(h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot)
+!$OMP THREADPRIVATE(h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot)
+  REAL        d_h_vcol, d_h_dair, d_qt, d_qw, d_ql, d_qs, d_ec
+  REAL        d_h_vcol_phy
+  REAL        fs_bound, fq_bound
+  SAVE        d_h_vcol_phy
+!$OMP THREADPRIVATE(d_h_vcol_phy)
+  REAL        zero_v(klon)
   CHARACTER *15 ztit
-  INTEGER ip_ebil ! PRINT level for energy conserv. diag.
-  SAVE ip_ebil
-  DATA ip_ebil/2/
-  !$OMP THREADPRIVATE(ip_ebil)
-  INTEGER if_ebil ! level for energy conserv. dignostics
-  SAVE if_ebil
-  DATA if_ebil/2/
-  !$OMP THREADPRIVATE(if_ebil)
-  ! +jld ec_conser
+  INTEGER     ip_ebil ! PRINT level for energy conserv. diag.
+  SAVE        ip_ebil
+  DATA        ip_ebil/2/
+!$OMP THREADPRIVATE(ip_ebil)
+  INTEGER     if_ebil ! level for energy conserv. dignostics
+  SAVE        if_ebil
+  DATA        if_ebil/2/
+!$OMP THREADPRIVATE(if_ebil)
+!+jld ec_conser
   REAL d_t_ec(klon, klev) ! tendance du a la conersion Ec -> E thermique
   REAL zrcpd
-  ! -jld ec_conser
-  ! LF
+!-jld ec_conser
+!LF
   INTEGER nloc
-  LOGICAL, SAVE :: first = .TRUE.
-  !$OMP THREADPRIVATE(first)
-  INTEGER, SAVE :: itap, igout
-  !$OMP THREADPRIVATE(itap, igout)
+  LOGICAL, SAVE            :: first = .TRUE.
+!$OMP THREADPRIVATE(first)
+  INTEGER, SAVE            :: itap, igout
+!$OMP THREADPRIVATE(itap, igout)
 
   include "YOMCST.h"
@@ -195,7 +210,7 @@
 
   IF (first) THEN
-    ! Allocate some variables LF 04/2008
-
-    ! IM/JYG allocate(cbmf(klon))
+! Allocate some variables LF 04/2008
+
+!IM/JYG allocate(cbmf(klon))
     ALLOCATE (ql(klon,klev))
     ALLOCATE (t1(klon,klev))
@@ -204,11 +219,11 @@
     igout = klon/2 + 1/klon
   END IF
-  ! Incrementer le compteur de la physique
+! Incrementer le compteur de la physique
   itap = itap + 1
 
-  ! Copy T into Tconv
+! Copy T into Tconv
   DO k = 1, klev
     DO i = 1, klon
-      tconv(i, k) = t(i, k)
+      Tconv(i, k) = t(i, k)
     END DO
   END DO
@@ -224,45 +239,44 @@
   END IF
 
-  ! ym
+! ym
   snow(:) = 0
 
-  ! IF (ifrst .EQ. 0) THEN
-  ! ifrst = 1
+! IF (ifrst .EQ. 0) THEN
+! ifrst = 1
   IF (first) THEN
     first = .FALSE.
 
-    ! ===========================================================================
-    ! READ IN PARAMETERS FOR THE CLOSURE AND THE MIXING DISTRIBUTION
-    ! ===========================================================================
+! ===========================================================================
+! READ IN PARAMETERS FOR THE CLOSURE AND THE MIXING DISTRIBUTION
+! ===========================================================================
 
     IF (iflag_con==3) THEN
-      ! CALL cv3_inicp()
+!      CALL cv3_inicp()
       CALL cv3_inip()
     END IF
 
-    ! ===========================================================================
-    ! READ IN PARAMETERS FOR CONVECTIVE INHIBITION BY TROPOS. DRYNESS
-    ! ===========================================================================
-
-    ! c$$$         open (56,file='supcrit.data')
-    ! c$$$         read (56,*) Supcrit1, Supcrit2
-    ! c$$$         close (56)
-
-    IF (prt_level>=10) WRITE (lunout, *) 'supcrit1, supcrit2', supcrit1, &
-      supcrit2
-
-    ! ===========================================================================
-    ! Initialisation pour les bilans d'eau et d'energie
-    ! ===========================================================================
+! ===========================================================================
+! READ IN PARAMETERS FOR CONVECTIVE INHIBITION BY TROPOS. DRYNESS
+! ===========================================================================
+
+! c$$$         open (56,file='supcrit.data')
+! c$$$         read (56,*) Supcrit1, Supcrit2
+! c$$$         close (56)
+
+    IF (prt_level>=10) WRITE (lunout, *) 'supcrit1, supcrit2', supcrit1, supcrit2
+
+! ===========================================================================
+! Initialisation pour les bilans d'eau et d'energie
+! ===========================================================================
     IF (if_ebil>=1) d_h_vcol_phy = 0.
 
     DO i = 1, klon
       cbmf(i) = 0.
-      ! !          plcl(i) = 0.
+!!          plcl(i) = 0.
       sigd(i) = 0.
     END DO
   END IF !(ifrst .EQ. 0)
 
-  ! Initialisation a chaque pas de temps
+! Initialisation a chaque pas de temps
   plfc(:) = 0.
   wbeff(:) = 100.
@@ -284,20 +298,20 @@
 
 
-  ! Feeding layer
+! Feeding layer
 
   em_sig1feed = 1.
   em_sig2feed = 0.97
-  ! em_sig2feed = 0.8
-  ! Relative Weight densities
+! em_sig2feed = 0.8
+! Relative Weight densities
   DO k = 1, klev
     em_wght(k) = 1.
   END DO
-  ! CRtest: couche alim des tehrmiques ponderee par a*
-  ! DO i = 1, klon
-  ! do k=1,lalim_conv(i)
-  ! em_wght(k)=wght_th(i,k)
-  ! print*,'em_wght=',em_wght(k),wght_th(i,k)
-  ! end do
-  ! END DO
+!CRtest: couche alim des tehrmiques ponderee par a*
+! DO i = 1, klon
+! do k=1,lalim_conv(i)
+! em_wght(k)=wght_th(i,k)
+! print*,'em_wght=',em_wght(k),wght_th(i,k)
+! end do
+! END DO
 
   IF (iflag_con==4) THEN
@@ -318,6 +332,5 @@
       END DO
     END DO
-  ELSE ! iflag_con=3 (modif de puristes qui fait la diffce pour la
-    ! convergence numerique)
+  ELSE ! iflag_con=3 (modif de puristes qui fait la diffce pour la convergence numerique)
     DO k = 1, klev
       DO i = 1, klon
@@ -342,47 +355,66 @@
   END IF ! iflag_con
 
-  ! ------------------------------------------------------------------
-
-  ! Main driver for convection:
-  ! iflag_con=3 -> nvlle version de KE (JYG)
-  ! iflag_con = 30  -> equivalent to convect3
-  ! iflag_con = 4  -> equivalent to convect1/2
+! ------------------------------------------------------------------
+
+! Main driver for convection:
+!                   iflag_con=3 -> nvlle version de KE (JYG)
+!                   iflag_con = 30  -> equivAlent to convect3
+!                   iflag_con = 4  -> equivAlent to convect1/2
 
 
   IF (iflag_con==30) THEN
 
-    ! print *, '-> cv_driver'      !jyg
-    CALL cv_driver(klon, klev, klevp1, ntra, iflag_con, t, q, qs, u, v, tra, &
-      em_p, em_ph, iflag, d_t, d_q, d_u, d_v, d_tra, rain, vprecip, cbmf, &
-      sig1, w01, &                 !jyg
-      kbas, ktop, dtime, ma, upwd, dnwd, dnwdbis, qcondc, wd, cape, da, phi, &
-      mp, phi2, d1a, dam, sij, clw, elij, & !RomP
-      evap, ep, epmlmmm, eplamm, & !RomP
-      wdtraina, wdtrainm) !RomP
-    ! print *, 'cv_driver ->'      !jyg
-
-    DO i = 1, klon
-      cbmf(i) = ma(i, kbas(i))
-    END DO
+! print *, '-> cv_driver'      !jyg
+    CALL cv_driver(klon, klev, klevp1, ntra, iflag_con, &
+                   t, q, qs, u, v, tra, &
+                   em_p, em_ph, iflag, &
+                   d_t, d_q, d_u, d_v, d_tra, rain, &
+                   Vprecip, cbmf, sig1, w01, & !jyg
+                   kbas, ktop, &
+                   dtime, Ma, upwd, dnwd, dnwdbis, qcondc, wd, cape, &
+                   da, phi, mp, phi2, d1a, dam, sij, clw, elij, &       !RomP
+                   evap, ep, epmlmMm, eplaMm, &                         !RomP
+                   wdtrainA, wdtrainM)                                  !RomP
+!           print *, 'cv_driver ->'      !jyg
+
+    DO i = 1, klon
+      cbmf(i) = Ma(i, kbas(i))
+    END DO
+
+!RL
+    wght(:, :) = 0.
+    DO i = 1, klon
+      wght(i, 1) = 1.
+    END DO
+!RL
 
   ELSE
 
-    ! LF   necessary for gathered fields
+!LF   necessary for gathered fields
     nloc = klon
-    CALL cva_driver(klon, klev, klev+1, ntra, nloc, iflag_con, iflag_mix, &
-      iflag_ice_thermo, iflag_clos, dtime, t, q, qs, t_wake, q_wake, qs_wake, &
-      s_wake, u, v, tra, em_p, em_ph, ale, alp, em_sig1feed, em_sig2feed, &
-      em_wght, iflag, d_t, d_q, d_u, d_v, d_tra, rain, kbas, ktop, cbmf, &
-      plcl, plfc, wbeff, sig1, w01, ptop2, sigd, ma, mip, vprecip, upwd, &
-      dnwd, dnwdbis, qcondc, wd, cape, cin, tvp, dd_t, dd_q, plim1, plim2, &
-      asupmax, supmax0, asupmaxmin, lalim_conv, & ! AC!+!RomP+jyg
-      da, phi, mp, phi2, d1a, dam, sij, clw, elij, & ! RomP
-      evap, ep, epmlmmm, eplamm, & ! RomP
-      wdtraina, wdtrainm) ! RomP
-    ! AC!+!RomP+jyg
+    CALL cva_driver(klon, klev, klev+1, ntra, nloc, &
+                    iflag_con, iflag_mix, iflag_ice_thermo, &
+                    iflag_clos, ok_conserv_q, dtime, &
+                    t, q, qs, t_wake, q_wake, qs_wake, s_wake, u, v, tra, &
+                    em_p, em_ph, &
+                    Ale, Alp, &
+                    em_sig1feed, em_sig2feed, em_wght, &
+                    iflag, d_t, d_q, d_u, d_v, d_tra, rain, kbas, ktop, &
+                    cbmf, plcl, plfc, wbeff, sig1, w01, ptop2, sigd, &
+                    Ma, mip, Vprecip, upwd, dnwd, dnwdbis, qcondc, wd, &
+                    cape, cin, tvp, &
+                    dd_t, dd_q, plim1, plim2, asupmax, supmax0, &
+                    asupmaxmin, lalim_conv, &
+!AC!+!RomP+jyg
+!!                   da,phi,mp,phi2,d1a,dam,sij,clw,elij, &               ! RomP
+!!                   evap,ep,epmlmMm,eplaMm,                              ! RomP
+                    da, phi, mp, phi2, d1a, dam, sij, wght, &           ! RomP+RL
+                    clw, elij, evap, ep, epmlmMm, eplaMm, &             ! RomP+RL
+                    wdtrainA, wdtrainM)                                 ! RomP
+!AC!+!RomP+jyg
   END IF
-  ! ------------------------------------------------------------------
-  IF (prt_level>=10) WRITE (lunout, *) ' cva_driver -> cbmf,plcl,plfc,wbeff ' &
-    , cbmf(1), plcl(1), plfc(1), wbeff(1)
+! ------------------------------------------------------------------
+  IF (prt_level>=10) WRITE (lunout, *) ' cva_driver -> cbmf,plcl,plfc,wbeff ', &
+                                         cbmf(1), plcl(1), plfc(1), wbeff(1)
 
   DO i = 1, klon
@@ -404,5 +436,6 @@
       DO k = 1, klev
         DO i = 1, klon
-          d_tra(i, k, itra) = dtime*d_tra(i, k, itra)
+!RL!            d_tra(i,k,itra) =dtime*d_tra(i,k,itra)
+          d_tra(i, k, itra) = 0.
         END DO
       END DO
@@ -410,15 +443,16 @@
   END IF
 
-  ! !AC!
+!!AC!
   IF (iflag_con==3) THEN
     DO itra = 1, ntra
       DO k = 1, klev
         DO i = 1, klon
-          d_tra(i, k, itra) = dtime*d_tra(i, k, itra)
+!RL!            d_tra(i,k,itra) =dtime*d_tra(i,k,itra)
+          d_tra(i, k, itra) = 0.
         END DO
       END DO
     END DO
   END IF
-  ! !AC!
+!!AC!
 
   DO k = 1, klev
@@ -428,30 +462,30 @@
     END DO
   END DO
-  ! !jyg
-  ! --Separation neige/pluie (pour diagnostics)       !jyg
-  DO k = 1, klev !jyg
-    DO i = 1, klon !jyg
-      IF (t1(i,k)<rtt) THEN !jyg
-        pmflxs(i, k) = vprecip(i, k) !jyg
-      ELSE !jyg
-        pmflxr(i, k) = vprecip(i, k) !jyg
-      END IF !jyg
-    END DO !jyg
-  END DO !jyg
-
-  ! c      IF (if_ebil.ge.2) THEN
-  ! c        ztit='after convect'
-  ! c        CALL diagetpq(paire,ztit,ip_ebil,2,2,dtime
-  ! c     e      , t1,q1,ql,qs,u,v,paprs,pplay
-  ! c     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-  ! c         call diagphy(paire,ztit,ip_ebil
-  ! c     e      , zero_v, zero_v, zero_v, zero_v, zero_v
-  ! c     e      , zero_v, rain, zero_v, ztsol
-  ! c     e      , d_h_vcol, d_qt, d_ec
-  ! c     s      , fs_bound, fq_bound )
-  ! c      END IF
-
-
-  ! les traceurs ne sont pas mis dans cette version de convect4:
+!                                                   !jyg
+! --Separation neige/pluie (pour diagnostics)       !jyg
+  DO k = 1, klev                                    !jyg
+    DO i = 1, klon                                  !jyg
+      IF (t1(i,k)<rtt) THEN                         !jyg
+        pmflxs(i, k) = Vprecip(i, k)                !jyg
+      ELSE                                          !jyg
+        pmflxr(i, k) = Vprecip(i, k)                !jyg
+      END IF                                        !jyg
+    END DO                                          !jyg
+  END DO                                            !jyg
+
+! c      IF (if_ebil.ge.2) THEN
+! c        ztit='after convect'
+! c        CALL diagetpq(paire,ztit,ip_ebil,2,2,dtime
+! c     e      , t1,q1,ql,qs,u,v,paprs,pplay
+! c     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+! c         call diagphy(paire,ztit,ip_ebil
+! c     e      , zero_v, zero_v, zero_v, zero_v, zero_v
+! c     e      , zero_v, rain, zero_v, ztsol
+! c     e      , d_h_vcol, d_qt, d_ec
+! c     s      , fs_bound, fq_bound )
+! c      END IF
+
+
+! les traceurs ne sont pas mis dans cette version de convect4:
   IF (iflag_con==4) THEN
     DO itra = 1, ntra
@@ -463,5 +497,5 @@
     END DO
   END IF
-  ! print*, 'concvl->: dd_t,dd_q ',dd_t(1,1),dd_q(1,1)
+! print*, 'concvl->: dd_t,dd_q ',dd_t(1,1),dd_q(1,1)
 
   DO k = 1, klev
@@ -478,25 +512,25 @@
   IF (prt_level>=20) THEN
     DO k = 1, klev
-      ! print*,'physiq apres_add_con i k it d_u d_v d_t d_q qdl0',igout
-      ! .,k,itap,d_u_con(igout,k) ,d_v_con(igout,k), d_t_con(igout,k),
-      ! .d_q_con(igout,k),dql0(igout,k)
-      ! print*,'phys apres_add_con itap Ma cin ALE ALP wak t q undi t q'
-      ! .,itap,Ma(igout,k),cin(igout),ALE(igout), ALP(igout),
-      ! . t_wake(igout,k),q_wake(igout,k),t_undi(igout,k),q_undi(igout,k)
-      ! print*,'phy apres_add_con itap CON rain snow EMA wk1 wk2 Vpp mip'
-      ! .,itap,rain_con(igout),snow_con(igout),ema_work1(igout,k),
-      ! .ema_work2(igout,k),Vprecip(igout,k), mip(igout,k)
-      ! print*,'phy apres_add_con itap upwd dnwd dnwd0 cape tvp Tconv '
-      ! .,itap,upwd(igout,k),dnwd(igout,k),dnwd0(igout,k),cape(igout),
-      ! .tvp(igout,k),Tconv(igout,k)
-      ! print*,'phy apres_add_con itap dtvpdt dtvdq dplcl dplcldr qcondc'
-      ! .,itap,dtvpdt1(igout,k),dtvpdq1(igout,k),dplcldt(igout),
-      ! .dplcldr(igout),qcondc(igout,k)
-      ! print*,'phy apres_add_con itap wd pmflxr Kpmflxr Kp1 Kpmflxs Kp1'
-      ! .,itap,wd(igout),pmflxr(igout,k),pmflxr(igout,k+1),pmflxs(igout,k)
-      ! .,pmflxs(igout,k+1)
-      ! print*,'phy apres_add_con itap da phi mp ftd fqd lalim wgth',
-      ! .itap,da(igout,k),phi(igout,k,k),mp(igout,k),ftd(igout,k),
-      ! . fqd(igout,k),lalim_conv(igout),wght_th(igout,k)
+! print*,'physiq apres_add_con i k it d_u d_v d_t d_q qdl0',igout, &
+!         k,itap,d_u_con(igout,k) ,d_v_con(igout,k), d_t_con(igout,k), &
+!         d_q_con(igout,k),dql0(igout,k)
+! print*,'phys apres_add_con itap Ma cin ALE ALP wak t q undi t q', &
+!         itap,Ma(igout,k),cin(igout),ALE(igout), ALP(igout), &
+!         t_wake(igout,k),q_wake(igout,k),t_undi(igout,k),q_undi(igout,k)
+! print*,'phy apres_add_con itap CON rain snow EMA wk1 wk2 Vpp mip', &
+!         itap,rain_con(igout),snow_con(igout),ema_work1(igout,k), &
+!         ema_work2(igout,k),Vprecip(igout,k), mip(igout,k)
+! print*,'phy apres_add_con itap upwd dnwd dnwd0 cape tvp Tconv ', &
+!         itap,upwd(igout,k),dnwd(igout,k),dnwd0(igout,k),cape(igout), &
+!         tvp(igout,k),Tconv(igout,k)
+! print*,'phy apres_add_con itap dtvpdt dtvdq dplcl dplcldr qcondc', &
+!         itap,dtvpdt1(igout,k),dtvpdq1(igout,k),dplcldt(igout), &
+!         dplcldr(igout),qcondc(igout,k)
+! print*,'phy apres_add_con itap wd pmflxr Kpmflxr Kp1 Kpmflxs Kp1', &
+!         itap,wd(igout),pmflxr(igout,k),pmflxr(igout,k+1),pmflxs(igout,k), &
+!         pmflxs(igout,k+1)
+! print*,'phy apres_add_con itap da phi mp ftd fqd lalim wgth', &
+!         itap,da(igout,k),phi(igout,k,k),mp(igout,k),ftd(igout,k), &
+!         fqd(igout,k),lalim_conv(igout),wght_th(igout,k)
     END DO
   END IF !(prt_level.EQ.20) THEN
Index: /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2056)
@@ -114,5 +114,6 @@
     real,save :: seuil_inversion_omp
 
-    integer,SAVE :: iflag_thermals_ed_omp,iflag_thermals_optflux_omp
+    integer,SAVE :: iflag_thermals_ed_omp,iflag_thermals_optflux_omp,iflag_thermals_closure_omp
+    real, SAVE :: fact_thermals_ed_dz_omp
     integer,SAVE :: iflag_thermals_omp,nsplit_thermals_omp
     real,save :: tau_thermals_omp,alp_bl_k_omp
@@ -145,6 +146,8 @@
     INTEGER,SAVE :: iflag_pdf_omp
     INTEGER,SAVE :: iflag_ice_thermo_omp
+    INTEGER,SAVE :: iflag_t_glace_omp
     REAL,SAVE :: rad_froid_omp, rad_chau1_omp, rad_chau2_omp
     REAL,SAVE :: t_glace_min_omp, t_glace_max_omp
+    REAL,SAVE :: exposant_glace_omp
     REAL,SAVE :: rei_min_omp, rei_max_omp
     REAL,SAVE :: inertie_sol_omp,inertie_sno_omp,inertie_ice_omp
@@ -179,4 +182,5 @@
     INTEGER, SAVE :: nbapp_rad_omp, iflag_con_omp
     INTEGER, SAVE :: iflag_ener_conserv_omp
+    LOGICAL, SAVE :: ok_conserv_q_omp
     INTEGER, SAVE :: iflag_fisrtilp_qsat_omp
     LOGICAL,SAVE :: ok_strato_omp
@@ -693,4 +697,13 @@
     iflag_ener_conserv_omp = -1
     CALL getin('iflag_ener_conserv',iflag_ener_conserv_omp)
+
+    !Config  Key  = ok_conserv_q
+    !Config  Desc = Switch des corrections de conservation de l'eau
+    !Config  Def  = y
+    !Config  Help = Switch des corrections de conservation de l'eau
+    !Config         y -> corrections activees
+    !Config         n -> conformite avec versions anterieures au 1/4/2014
+    ok_conserv_q_omp = .FALSE.
+    CALL getin('ok_conserv_q',ok_conserv_q_omp)
 
     !Config  Key  = iflag_fisrtilp_qsat
@@ -1005,4 +1018,22 @@
 
     !
+    !Config Key  = exposant_glace
+    !Config Desc =  
+    !Config Def  = 2.
+    !Config Help = 
+    !
+    exposant_glace_omp = 1.
+    call getin('exposant_glace',exposant_glace_omp)
+
+    !
+    !Config Key  = iflag_t_glace
+    !Config Desc =  
+    !Config Def  = 0
+    !Config Help = 
+    !
+    iflag_t_glace_omp = 0
+    call getin('iflag_t_glace',iflag_t_glace_omp)
+
+    !
     !Config Key  = iflag_ice_thermo
     !Config Desc =  
@@ -1142,4 +1173,13 @@
     call getin('iflag_thermals',iflag_thermals_omp)
     !
+    !Config Key  = iflag_thermals_ed
+    !Config Desc =
+    !Config Def  = 0
+    !Config Help =
+    !
+    fact_thermals_ed_dz_omp = 0.1
+
+    call getin('fact_thermals_ed_dz',fact_thermals_ed_dz_omp)
+    !
     !
     !Config Key  = iflag_thermals_ed
@@ -1159,4 +1199,14 @@
     iflag_thermals_optflux_omp = 0
     call getin('iflag_thermals_optflux',iflag_thermals_optflux_omp)
+    !
+    !Config Key  = iflag_thermals_closure
+    !Config Desc =
+    !Config Def  = 0
+    !Config Help =
+    !
+    iflag_thermals_closure_omp = 1
+    call getin('iflag_thermals_closure',iflag_thermals_closure_omp)
+    !
+    !
     !
     !
@@ -1718,4 +1768,5 @@
     iflag_con = iflag_con_omp
     iflag_ener_conserv = iflag_ener_conserv_omp
+    ok_conserv_q = ok_conserv_q_omp
     iflag_fisrtilp_qsat = iflag_fisrtilp_qsat_omp
 
@@ -1744,4 +1795,6 @@
     t_glace_min = t_glace_min_omp
     t_glace_max = t_glace_max_omp
+    exposant_glace = exposant_glace_omp
+    iflag_t_glace = iflag_t_glace_omp
     iflag_ice_thermo = iflag_ice_thermo_omp
     rei_min = rei_min_omp
@@ -1813,5 +1866,7 @@
     iflag_thermals = iflag_thermals_omp
     iflag_thermals_ed = iflag_thermals_ed_omp
+    fact_thermals_ed_dz = fact_thermals_ed_dz_omp
     iflag_thermals_optflux = iflag_thermals_optflux_omp
+    iflag_thermals_closure = iflag_thermals_closure_omp
     nsplit_thermals = nsplit_thermals_omp
     tau_thermals = tau_thermals_omp
@@ -1940,4 +1995,5 @@
     write(lunout,*)'iflag_con=',iflag_con
     write(lunout,*)'iflag_ener_conserv=',iflag_ener_conserv
+    write(lunout,*)'ok_conserv_q=',ok_conserv_q
     write(lunout,*)'iflag_fisrtilp_qsat=',iflag_fisrtilp_qsat
     write(lunout,*)' epmax = ', epmax
@@ -1971,4 +2027,6 @@
     write(lunout,*)' t_glace_min = ',t_glace_min
     write(lunout,*)' t_glace_max = ',t_glace_max
+    write(lunout,*)' exposant_glace = ',exposant_glace
+    write(lunout,*)' iflag_t_glace = ',iflag_t_glace
     write(lunout,*)' iflag_ice_thermo = ',iflag_ice_thermo
     write(lunout,*)' rei_min = ',rei_min
@@ -2004,5 +2062,7 @@
     write(lunout,*)' iflag_thermals = ', iflag_thermals
     write(lunout,*)' iflag_thermals_ed = ', iflag_thermals_ed
+    write(lunout,*)' fact_thermals_ed_dz = ', fact_thermals_ed_dz
     write(lunout,*)' iflag_thermals_optflux = ', iflag_thermals_optflux
+    write(lunout,*)' iflag_thermals_closure = ', iflag_thermals_closure
     write(lunout,*)' iflag_clos = ', iflag_clos
     write(lunout,*)' type_run = ',type_run 
